---
sidebar_position: 1
---

# 💻 OpenDevin

OpenDevin is an **autonomous AI software engineer** capable of executing complex engineering tasks and collaborating actively with users on software development projects.
This project is fully open-source, so you can use and modify it however you like.

:::tip
Explore the codebase of OpenDevin on [GitHub](https://github.com/OpenDevin/OpenDevin) or join one of our communities!

<a href="https://github.com/OpenDevin/OpenDevin/graphs/contributors">
  <img
    src="https://img.shields.io/github/contributors/opendevin/opendevin?style=for-the-badge"
    alt="Contributors"
  />
</a>
<a href="https://github.com/OpenDevin/OpenDevin/network/members">
  <img
    src="https://img.shields.io/github/forks/opendevin/opendevin?style=for-the-badge"
    alt="Forks"
  />
</a>
<a href="https://github.com/OpenDevin/OpenDevin/stargazers">
  <img
    src="https://img.shields.io/github/stars/opendevin/opendevin?style=for-the-badge"
    alt="Stargazers"
  />
</a>
<a href="https://github.com/OpenDevin/OpenDevin/issues">
  <img
    src="https://img.shields.io/github/issues/opendevin/opendevin?style=for-the-badge"
    alt="Issues"
  />
</a>
<br></br>
<a href="https://github.com/OpenDevin/OpenDevin/blob/main/LICENSE">
  <img
    src="https://img.shields.io/github/license/opendevin/opendevin?style=for-the-badge"
    alt="MIT License"
  />
</a>
<br></br>
<a href="https://join.slack.com/t/opendevin/shared_invite/zt-2jsrl32uf-fTeeFjNyNYxqSZt5NPY3fA">
  <img
    src="https://img.shields.io/badge/Slack-Join%20Us-red?logo=slack&logoColor=white&style=for-the-badge"
    alt="Join our Slack community"
  />
</a>
<a href="https://discord.gg/ESHStjSjD4">
  <img
    src="https://img.shields.io/badge/Discord-Join%20Us-purple?logo=discord&logoColor=white&style=for-the-badge"
    alt="Join our Discord community"
  />
</a>
:::

## 🛠️ Getting Started

The easiest way to run OpenDevin is inside a Docker container. It works best with the most recent version of Docker, `26.0.0`.
You must be using Linux, Mac OS, or WSL on Windows.

To start OpenDevin in a docker container, run the following commands in your terminal:

:::warning
When you run the following command, files in `./workspace` may be modified or deleted.
:::

```bash
WORKSPACE_BASE=$(pwd)/workspace
docker run -it \
    --pull=always \
    -e SANDBOX_USER_ID=$(id -u) \
    -e WORKSPACE_MOUNT_PATH=$WORKSPACE_BASE \
    -v $WORKSPACE_BASE:/opt/workspace_base \
    -v /var/run/docker.sock:/var/run/docker.sock \
    -p 3000:3000 \
    --add-host host.docker.internal:host-gateway \
    --name opendevin-app-$(date +%Y%m%d%H%M%S) \
    ghcr.io/opendevin/opendevin
```

:::note
By default, this command pulls the `latest` tag, which represents the most recent stable release of OpenDevin. You have other options as well:

- For a specific release version, use `ghcr.io/opendevin/opendevin:0.7` (replace 0.7 with the desired version number).
- For the most up-to-date development version, use `ghcr.io/opendevin/opendevin:main`. Note that this version may be **(unstable!)** and is recommended for testing or development purposes only.

Choose the tag that best suits your needs based on stability requirements and desired features.
:::

You'll find OpenDevin running at [http://localhost:3000](http://localhost:3000) with access to `./workspace`. To have OpenDevin operate on your code, place it in `./workspace`.

OpenDevin will only have access to this workspace folder. The rest of your system will not be affected as it runs in a secured docker sandbox.

For the development workflow, see [Development.md](https://github.com/OpenDevin/OpenDevin/blob/main/Development.md).

Are you having trouble? Check out our [Troubleshooting Guide](https://opendevin.github.io/OpenDevin/modules/usage/troubleshooting).

:::warning
OpenDevin is currently a work in progress, but you can already run the alpha version to see the end-to-end system in action.
:::

[contributors-shield]: https://img.shields.io/github/contributors/opendevin/opendevin?style=for-the-badge
[contributors-url]: https://github.com/OpenDevin/OpenDevin/graphs/contributors
[forks-shield]: https://img.shields.io/github/forks/opendevin/opendevin?style=for-the-badge
[forks-url]: https://github.com/OpenDevin/OpenDevin/network/members
[stars-shield]: https://img.shields.io/github/stars/opendevin/opendevin?style=for-the-badge
[stars-url]: https://github.com/OpenDevin/OpenDevin/stargazers
[issues-shield]: https://img.shields.io/github/issues/opendevin/opendevin?style=for-the-badge
[issues-url]: https://github.com/OpenDevin/OpenDevin/issues
[license-shield]: https://img.shields.io/github/license/opendevin/opendevin?style=for-the-badge
[license-url]: https://github.com/OpenDevin/OpenDevin/blob/main/LICENSE
